local _G = _G;
local GetTime = GetTime
local string, ipairs = string, ipairs
local table_insert, table_remove , table_getn = table.insert, table.remove, table.getn
local print, string_format, string_gmatch, string_length, string_sub, math_floor= print, string.format, string.gmatch, string.len, string.sub, math.floor
local red = RED_FONT_COLOR
local UnrealTargets = CreateFrame('Frame', "UnrealTargets", UIParent)
local UnrealTargets_options = {};
local testbar
local newtabs = true
local config = {}
config.height = 15
config.width = 150
config.rafter_distance = 5
config.posix = 300
config.posiy = 0


local unitdb = {}
unitdb.isinfight = false
unitdb.frostwolf = {}
unitdb.units = {}
unitdb.unitsmaxhp = {}
unitdb.slider = 0

unitdb.ignornpc = {47649 -- wildpilz
	,95582 -- Armee der toten
	,24207 -- Vogel
	,15439 -- Totem des Feuerelementars
	,29264 -- Geisterwolf
	,82521 -- Entweihen
	,3527 -- Totem des heilenden Flusses
	,60199 -- Rune der Macht
	,47243 -- Spiegelbild
	,59764 -- Totem der Heilungsflut
	,77789 -- Blingtron 5000
	,416 -- Wichtel
	,31216 -- Spiegelbild
	,5929 -- Totem des glühenden Magmas
	,93828 -- Trainingsattrappe
	,45322 -- Gefrorene Kugel
	,62982 -- Geistbeuger
	,61245 -- Totem der Energiespeicherung
	,54983 -- Treant
	,77934 -- Totem des Sturmelementars
	,77936 -- Großer Sturmelementar
	,55659 -- Wildwichtel
	,2523 -- Totem der Verbrennung
	,90610 -- Teufelsfeuermunition
	,78158 -- Verdammniswache
	,15438 -- Großer Feuerelementar
	,46490 -- Wächter der Uralten Könige
	,53006 -- Totem der Geistverbindung
	,59000 -- Terrorwache
	,47319 -- Gezielter Sprung
	,60849 -- Statue der Jadeschlange
	,92993 -- Spiegelbild
	,63508 -- Xuen
	,92624 -- Streitkolben
	,76168 -- Verheerer
	,92587 -- Schwert
	,92919 -- Restenergie
	,76933 -- Kristallprisma
	,11859 -- Verdammniswache
	,27893 -- Runenklinge
	,73967 -- Xuen
	,61146 -- Statue des Schwarzen Ochsen
	,35642 -- Jeeves
	,94729 -- Kohlenbecken des Erwachens
	,59607 -- Spektralerscheinung
	,59712 -- Totem des Steinbollwerks
	,96115 -- Schlachtstandarte von Vol'jins Kopfjägern
	,94852 -- Feenmondschwinge
	,19668 -- Schattengeist
	,89194 -- Ausgedörrte Echse
	,94922 -- Lady Jaina Prachtmeer
	,94946 -- Arthas Menethil
	,94879 -- Tyrande Wisperwind
	,92893 -- Axt
	,94925 -- Fürstin Sylvanas Windläufer
	,77726 -- Schattenreflexion
	,27829 -- Schwarzer Gargoyle
	,54569 -- Transzendenzgeist
	,76917 -- <Persönliches Hologramm>
	,5925 -- Totem der Erdung
	,15352 -- Großer Erdelementar
	,15430 -- Totem des Erdelementars
	,61029 -- Urfeuerelementar
	,60561 -- Totem des Erdgriffs
	,64571 -- Lichtbrunnen
	,61056 -- Urerdelementar
	,40703 -- Megazord
	,91326 -- Gul'dan
	,59717 -- Totem des Windwandelns
	,5913 -- Totem des Erdstoßes
	,92208 -- Verdammnisfeuergeist
	,59738 -- Hammer des Lichts
	,4277 -- Auge von Kilrogg
	,67235 -- Schattengeist
	,80302 -- Wächterkugel
	,86945 -- Hexenmeisterin von Haus Sonnenschwur
	,89 -- Höllenbestie
	,86933 -- Magierin des Kriegsspeers
	,69680 -- Sturmgeist
	,58542 -- Vergangenes Selbst
	 ,88380 -- Grunzerin
	,88393 -- Grunzerin
	,88391 -- Garnisonsschütze
	,67236 -- Geistbeuger
	,95455 -- Verderbter urzeitlicher Obelisk
	,88435 -- Wächter der Schmiede
	,78215 -- Verirorok
	,61711 -- Wassertotem
	,61714 -- Lufttotem
	,61713 -- Erdtotem
	,69792 -- Erdgeist
	,77942 -- Ursturmelementar
	,87061 -- Schattengeist
	,88050 -- Frostwolf
	,31897 -- Lichtbrunnen
	,86946 -- Ausgestoßener Krallenpriester
	,62182 -- Amethystschieferjungtier
	,86964 -- Erdbinder der Blutmähnen
	,58997 -- Abyssal
	,86682 -- Pensionierter gorianischer Zenturio
	,69791 -- Feuergeist
	,59390 -- Spottendes Banner
	,48638 -- Schlachtstandarte der Gilde
	,84774 -- Tödliche Eisenfalle
	,83925 -- Eisenfalle
	,44199 -- Ring des Frosts
	,77894 -- Walter
	,95468 -- Satyr der Illidari
	,95469 -- Bösartiger Höllenhund
	,86951 -- Wolf aus Nagrand
	,86187 -- Tier
	,65282 -- Leerententakel
	,61712 -- Feuertotem
	,56194 -- Spinnenjungtier
	}

-- 90432 FAIL	
	
function cmdut(arg)
	
	if arg == "test" then
		unitdb.slider:SetValue(6)
	elseif  arg == "test2" then
		
	elseif  arg == "reset" then
		UnrealTargets:reset_frames()
	end	
end

function UnrealTargets:option_slider(name, uiparent, anocher, posix, posiy, minvale, maxvalue, titlename, databasevalue) 
	local slider = CreateFrame("Slider", name ,uiparent,"OptionsSliderTemplate")
	slider:SetPoint(anocher, posix, posiy)
	slider.textLow = _G[name.."Low"]
	slider.textHigh = _G[name.."High"]
	slider.text = _G[name.."Text"]
	slider:SetMinMaxValues(minvale, maxvalue)
	slider.minValue, slider.maxValue = slider:GetMinMaxValues() 
	slider.textLow:SetText(slider.minValue)
	slider.textHigh:SetText(slider.maxValue)
	slider.text:SetText(titlename)
	slider:SetValue(databasevalue)
	slider:SetValueStep(1)
	
	slider.editBox = CreateFrame("EditBox", "edittest"..name, slider, "InputBoxTemplate")
	slider.editBox:SetWidth(30)
	slider.editBox:SetHeight(8)
	--slider.editBox:SetFontObject(GameFontNormal)
	--slider.editBox:SetBackdrop(GameTooltip:GetBackdrop())
	slider.editBox:SetBackdropColor(0, 0, 0, 0.8)
	slider.editBox:SetBackdropBorderColor(0.6, 0.6, 0.6, 1)
	slider.editBox:SetPoint("Topleft", 62, -20)
	slider.editBox:ClearFocus(self)
	slider.editBox:SetAutoFocus(false)	
	return slider
end


-------------------------------------
SlashCmdList["cmdut"] = cmdut; 
SLASH_cmdut1 = "/utar";
SLASH_cmdut2 = "/UnrealTargets";
SLASH_cmdut3 = "/unrealtargets";
SLASH_cmdut4 = "/unrealtarget";
unitdb.slider ={}

UnrealTargets_options = {};
UnrealTargets_options.panel = CreateFrame("ScrollFrame", "UnrealTargetsPanel", UIParent );
UnrealTargets_options.panel.name = "UnrealTargets";
UnrealTargets_options.panel.okay = 
function (self)
	self.originalValue = MY_VARIABLE;
end
InterfaceOptions_AddCategory(UnrealTargets_options.panel)


unitdb.header1 = UnrealTargets_options.panel:CreateFontString(nil, "OVERLAY", "GameTooltipText")
unitdb.header1:SetPoint("Topleft",200, -40)
unitdb.header1:SetText("Bar Options")
unitdb.header1:SetFont("Fonts\\FRIZQT__.ttf",18,"OUTLINE")
unitdb.header1:SetTextColor(red.r, red.g, red.b)

local name = "resetbutton"
local template = "UIPanelButtonTemplate"
local button = CreateFrame("Button", name, UnrealTargetsPanel, "UIPanelButtonTemplate") --frameType, frameName, frameParent, frameTemplate    
button:SetSize(50,15)
button:SetPoint("Topleft",10, -10)
button.text = _G[name.."Text"]
button.text:SetText("Reset")
button:SetScript("OnClick", function(self, ...) 
	print("reset")
	config.height = 15
	config.width = 150
	config.rafter_distance = 5
	config.posix = 300
	config.posiy = 0
	unitdb.slider.height:SetValue(config.height)
	unitdb.slider.width:SetValue(config.width)
	unitdb.slider.rafter_distance:SetValue(config.rafter_distance)
	unitdb.slider.posix:SetValue(config.posix)
	unitdb.slider.posiy:SetValue(config.posiy)
end)

unitdb.slider.height = UnrealTargets:option_slider("height", UnrealTargetsPanel, "TOPLEFT", 10, -80, 4, 50, "Height", config.height)
unitdb.slider.height:SetScript("OnValueChanged", function(self,event,arg1) 
	event = round(event)
	self:SetValue(event)
	config.height = event
	unitdb.slider.height.editBox:SetText(event)
end)
unitdb.slider.height.editBox:SetScript( "OnEnterPressed", function(self) 
	local value = unitdb.slider.height.editBox:GetText()
	value = tonumber(value) or config.height
	if value > 50 then
		value = 50
	elseif value < 4 then
		value = 4
	end
	unitdb.slider.height.editBox:SetText(value)
	config.height = value
	unitdb.slider.height:SetValue(value)
	self:ClearFocus()		
end)
unitdb.slider.height.editBox:SetScript( "OnEscapePressed", function(self)
	unitdb.slider.height.editBox:SetText(config.height)
	self:ClearFocus()
end)

unitdb.slider.width = UnrealTargets:option_slider("width", UnrealTargetsPanel, "TOPLEFT", 185, -80, 25, 500, "Width", config.width)
unitdb.slider.width:SetScript("OnValueChanged", function(self,event,arg1) 
	event = round(event)
	self:SetValue(event)
	config.width = event
	unitdb.slider.width.editBox:SetText(event)
end)
unitdb.slider.width.editBox:SetScript( "OnEnterPressed", function(self) 
	local value = unitdb.slider.width.editBox:GetText()
	value = tonumber(value) or config.width
	if value > 500 then
		value = 500
	elseif value < 25 then
		value = 25
	end
	unitdb.slider.width.editBox:SetText(value)
	config.width = value
	unitdb.slider.width:SetValue(value)
	self:ClearFocus()		
end)
unitdb.slider.width.editBox:SetScript( "OnEscapePressed", function(self)
	unitdb.slider.width.editBox:SetText(config.width)
	self:ClearFocus()
end)

unitdb.slider.rafter_distance = UnrealTargets:option_slider("rafter_distance", UnrealTargetsPanel, "TOPLEFT", 360, -80, 0, 25, "Bar-Distance", config.rafter_distance)
unitdb.slider.rafter_distance:SetScript("OnValueChanged", function(self,event,arg1) 
	event = round(event)
	self:SetValue(event)
	config.rafter_distance = event
	unitdb.slider.rafter_distance.editBox:SetText(event)
end)
unitdb.slider.rafter_distance.editBox:SetScript( "OnEnterPressed", function(self) 
	local value = unitdb.slider.rafter_distance.editBox:GetText()
	value = tonumber(value) or config.rafter_distance
	if value > 25 then
		value = 25
	elseif value < 0 then
		value = 0
	end
	unitdb.slider.rafter_distance.editBox:SetText(value)
	config.rafter_distance = value
	unitdb.slider.rafter_distance:SetValue(value)
	self:ClearFocus()		
end)
unitdb.slider.rafter_distance.editBox:SetScript( "OnEscapePressed", function(self)
	unitdb.slider.rafter_distance.editBox:SetText(config.rafter_distance)
	self:ClearFocus()
end)

unitdb.slider.posix = UnrealTargets:option_slider("posix", UnrealTargetsPanel, "TOPLEFT", 10, -140, -1000, 1000, "X-position", config.posix)
unitdb.slider.posix:SetScript("OnValueChanged", function(self,event,arg1) 
	event = round(event)
	self:SetValue(event)
	config.posix = event
	unitdb.slider.posix.editBox:SetText(event)
end)
unitdb.slider.posix.editBox:SetScript( "OnEnterPressed", function(self) 
	local value = unitdb.slider.posix.editBox:GetText()
	value = tonumber(value) or config.posix
	if value > 1000 then
		value = 1000
	elseif value < -1000 then
		value = -1000
	end
	unitdb.slider.posix.editBox:SetText(value)
	config.posix = value
	unitdb.slider.posix:SetValue(value)
	self:ClearFocus()		
end)
unitdb.slider.posix.editBox:SetScript( "OnEscapePressed", function(self)
	unitdb.slider.posix.editBox:SetText(config.posix)
	self:ClearFocus()
end)

unitdb.slider.posiy = UnrealTargets:option_slider("posiy", UnrealTargetsPanel, "TOPLEFT", 185, -140, -1000, 1000, "Y-position", config.posiy)
unitdb.slider.posiy:SetScript("OnValueChanged", function(self,event,arg1) 
	event = round(event)
	self:SetValue(event)
	config.posiy = event
	unitdb.slider.posiy.editBox:SetText(event)
end)
unitdb.slider.posiy.editBox:SetScript( "OnEnterPressed", function(self) 
	local value = unitdb.slider.posiy.editBox:GetText()
	value = tonumber(value) or config.posiy
	if value > 1000 then
		value = 1000
	elseif value < -1000 then
		value = -1000
	end
	unitdb.slider.posiy.editBox:SetText(value)
	config.posiy = value
	unitdb.slider.posiy:SetValue(value)
	self:ClearFocus()		
end)
unitdb.slider.posiy.editBox:SetScript( "OnEscapePressed", function(self)
	unitdb.slider.posiy.editBox:SetText(config.posiy)
	self:ClearFocus()
end)
---------------------------	



function round(num, ...)
	local idp = ... or 0
	local mult = 10^(idp or 0)
	return math_floor(num * mult + 0.5) / mult
end

function UnrealTargets:set_hp_frame(posix, posiy)
	local NewStatusBar = CreateFrame("StatusBar", nil, UIParent)
	NewStatusBar:SetStatusBarTexture('Interface/Buttons/GreyscaleRamp64')
	NewStatusBar:SetBackdrop({
				bgFile = "Interface/Buttons/GreyscaleRamp64",
				edgeFile = "Interface/Buttons/WHITE8X8",
				edgeSize = 1,
			});
	NewStatusBar:SetBackdropBorderColor(1,1,1,1);
	NewStatusBar:SetBackdropColor(1,1,1,0.2);
	NewStatusBar:GetStatusBarTexture():SetHorizTile(false)
	NewStatusBar:SetMinMaxValues(0, 100)
	NewStatusBar:SetValue(100)
	NewStatusBar:SetWidth(config.width)
	NewStatusBar:SetHeight(config.height)
	NewStatusBar:SetPoint("CENTER",posix, posiy)
	local c = red;
	NewStatusBar:SetStatusBarColor(c.r, c.g, c.b)
	return NewStatusBar
end

function UnrealTargets:Initialize()
	local value2 = config.height
	unitdb.slider.height.editBox:SetText(value2)
end



function UnrealTargets:frequently_frame_update(...)
	guid = UnitGUID(...)
	local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid)
	local max_health = UnitHealthMax(...)
	local currenthealth = UnitHealth(...)
	if max_health ~= 0 and currenthealth ~= 0 then
		if npc_id then
			unitdb.unitsmaxhp[npc_id] = {}
			unitdb.unitsmaxhp[npc_id].maxhp = max_health
			for i, unitguid in ipairs(unitdb.frostwolf) do
				if unitguid == guid then
					unitdb.units[guid].maxhp = max_health
					unitdb.units[guid].hp = currenthealth
					local health = unitdb.units[guid].hp / unitdb.units[guid].maxhp * 100
					health = string_format("%.0f", health)
					unitdb.units[guid].bar:SetValue(health)
					health = health.."%"
					unitdb.units[guid].fonthppercent:SetText(health)
				end
			end
		end
	end
	for k, unitguid in ipairs(unitdb.frostwolf) do
		if unitguid == destGUID then
			unitdb.units[destGUID].hp = unitdb.units[destGUID].hp - dmg
			local health = unitdb.units[destGUID].hp / unitdb.units[destGUID].maxhp * 100
			health = string_format("%.0f", health)
			unitdb.units[destGUID].bar:SetValue(health)
			health = health.."%"
			unitdb.units[destGUID].fonthppercent:SetText(health)
		end
	end
end

function UnrealTargets:frame_update(time, event,hide,srcGUID,srcName,srcF1,srcF2,destGUID,destName, ...)
	local type, _, _, _, _, npc_id, _ = strsplit("-",destGUID)
	local sourcetype = strsplit("-",srcGUID)
	local unit = destName
	local isindb = false
	local ignornpcid = false
	for i, unitguid in ipairs(unitdb.frostwolf) do
		if unitguid == destGUID then
			if unit ~= "player" then
				if event == "UNIT_DIED" then
					table_remove(unitdb.frostwolf, i)
					unitdb.units[unitguid].bar:Hide()
					for j, upunitguid in ipairs(unitdb.frostwolf) do
						unitdb.units[upunitguid].bar:SetPoint("CENTER",config.posix, config.posiy-(j-1)*(config.rafter_distance+config.height))
					end
				elseif event == "SWING_DAMAGE" then
					_,_, dmg = ...
					self:hp_update(destGUID, dmg)
				elseif event == "SPELL_DAMAGE" then
					_,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
				elseif event == "SPELL_PERIODIC_DAMAGE" then
					_,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
				end
			end
			isindb = true
		end
	end
	if not isindb then
		if type == "Creature" and sourcetype == "Player" or type == "Vehicle" and sourcetype == "Player"then
			if unitdb.isinfight == true then
				ignornpcid = self:ignor_npc(npc_id)
				if ignornpcid == false then
					SendChatMessage(","..npc_id.." -- "..destName, "CHANNEL", nil,  GetChannelName("myaddon"))
					table_insert(unitdb.frostwolf, destGUID)
					unitdb.units[destGUID] = {}
					if unitdb.unitsmaxhp[npc_id] then
						unitdb.units[destGUID].maxhp = unitdb.unitsmaxhp[npc_id].maxhp
					else
						unitdb.units[destGUID].maxhp = 1000000
					end
					unitdb.units[destGUID].hp = unitdb.units[destGUID].maxhp
					unitdb.units[destGUID].npcid = npc_id
					unitdb.units[destGUID].bar = UnrealTargets:set_hp_frame(config.posix, config.posiy-table_getn(unitdb.frostwolf)*(config.rafter_distance+config.height))
					unitdb.units[destGUID].fontname = unitdb.units[destGUID].bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
					unitdb.units[destGUID].fontname:SetPoint("LEFT", 0, 0)
					local targetname = self:cut_name(destName)
					unitdb.units[destGUID].fontname:SetText(targetname)
					unitdb.units[destGUID].fontname:SetFont("Fonts\\FRIZQT__.ttf",11,"OUTLINE")
					unitdb.units[destGUID].fonthppercent = unitdb.units[destGUID].bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
					unitdb.units[destGUID].fonthppercent:SetPoint("RIGHT", 0, 0)
					unitdb.units[destGUID].fonthppercent:SetFont("Fonts\\FRIZQT__.ttf",11,"OUTLINE")
				end
			end
		end
	end
end

function UnrealTargets:cut_name(name)
	local max_length = 18
	local length = string_length(name)
	if length > max_length + 2 then
		name = string_sub(name, 0, max_length)
		name = name..".."
	end
	return name
end

function UnrealTargets:ignor_npc(npc_id)
	for i, unitid in ipairs(unitdb.ignornpc) do
		if tonumber(npc_id) == unitid then
			return true
		end
	end
	return false
end

function UnrealTargets:hp_update(destGUID, dmg)
	unitdb.units[destGUID].hp = unitdb.units[destGUID].hp - dmg
	local health = unitdb.units[destGUID].hp / unitdb.units[destGUID].maxhp * 100
	health = string_format("%.0f", health)
	unitdb.units[destGUID].bar:SetValue(health)
	health = health.."%"
	unitdb.units[destGUID].fonthppercent:SetText(health)
end

function UnrealTargets:npcmaxhp_update()
	local max_health = UnitHealthMax("target")
	local currenthealth = UnitHealth("target")
	if max_health ~= 0 and currenthealth ~= 0 then
		--print("true "..max_health)
		local guid = UnitGUID("target")
		local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid)
		if npc_id then
			unitdb.unitsmaxhp[npc_id] = {}
			unitdb.unitsmaxhp[npc_id].maxhp = max_health
			for i, unitguid in ipairs(unitdb.frostwolf) do
				if unitguid == guid then
					unitdb.units[guid].maxhp = max_health
					unitdb.units[guid].hp = currenthealth
					local health = unitdb.units[guid].hp / unitdb.units[guid].maxhp * 100
					health = string_format("%.0f", health)
					unitdb.units[guid].bar:SetValue(health)
					health = health.."%"
					unitdb.units[guid].fonthppercent:SetText(health)
				end
				if npc_id == unitdb.units[unitguid].npcid then
					local deltahp = unitdb.units[unitguid].maxhp - unitdb.units[unitguid].hp 
					unitdb.units[unitguid].maxhp = max_health
					unitdb.units[unitguid].hp = unitdb.units[unitguid].maxhp -deltahp
					self:hp_update(unitguid, 0)
				end		
			end
		end
	end
end

function UnrealTargets:reset_frames()
	for k, unitguid in ipairs(unitdb.frostwolf) do
		unitdb.units[unitguid].bar:Hide()
		unitdb.units[unitguid] = {}
		table_remove(unitdb.frostwolf, 0)
	end
	unitdb.frostwolf = {}
	unitdb.units = {}
end

UnrealTargets:SetScript("OnUpdate", function(self, frame) 
	
end)

function UnrealTargets:OnEvent(event, ...)
	if event == 'PLAYER_LOGIN' then
		self:Initialize(...)
		--UnrealTargets:target_updates()
		--print("login")
	elseif event == 'COMBAT_LOG_EVENT_UNFILTERED' then
		self:frame_update(...)
	elseif event == 'PLAYER_TARGET_CHANGED' then
		self:npcmaxhp_update()
	elseif event == 'ENCOUNTER_END' then
		self:reset_frames()
		unitdb.isinfight = false
	elseif event == 'PLAYER_REGEN_ENABLED' then
		self:reset_frames()
		unitdb.isinfight = false
	elseif event == 'ENCOUNTER_START' then
		unitdb.isinfight = true
	elseif event == 'PLAYER_REGEN_DISABLED' then
		unitdb.isinfight = true
	elseif event == 'UNIT_HEALTH_FREQUENT' then
		self:frequently_frame_update(...)
	end
	return
end

function OnEvent(self, event, ...)
	UnrealTargets:OnEvent(event, ...)
end

UnrealTargets:RegisterEvent('GROUP_ROSTER_UPDATE')
UnrealTargets:RegisterEvent('PLAYER_LOGIN')
UnrealTargets:RegisterEvent('UNIT_HEALTH_FREQUENT')
UnrealTargets:RegisterEvent('PLAYER_TARGET_CHANGED')
UnrealTargets:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED');
UnrealTargets:RegisterEvent('ENCOUNTER_END')
UnrealTargets:RegisterEvent('PLAYER_REGEN_ENABLED')
UnrealTargets:RegisterEvent('ENCOUNTER_START')
UnrealTargets:RegisterEvent('PLAYER_REGEN_DISABLED')
UnrealTargets:SetScript('OnEvent', OnEvent)



